<template>
	<main v-if="state === LoginState.Sent">
		<h1>Check your inbox</h1>
		<p>A magic link has been sent to your email address.</p>
		<p>The link will expire in 30 minutes.</p>
		<p>You may close this tab.</p>
	</main>
	<main v-else-if="state === LoginState.WebAuthn">
		<h1>2-Factor authentication</h1>
		<p>Please insert your security key and press the button.</p>
	</main>
	<main v-else-if="state === LoginState.Banned">
		<h1>Banned</h1>
		<p>You have been banned by an administrator.</p>
		<p>If you believe this is an error, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</main>
	<main v-else-if="state === LoginState.Error">
		<h1>Error</h1>
		<pre>{{ error }}</pre>
		<p>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</main>
	<main v-else-if="state === LoginState.Limit">
		<h1>Slow down</h1>
		<p>You are sending too many login requests too quickly.</p>
		<p v-if="retry > 0">Please try again in {{ retry }} second(s).</p>
		<p v-else>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</main>
	<main v-else-if="state === LoginState.Primary">
		<h1>Non-primary identity</h1>
		<p>Please use your primary email address to log in.</p>
		<p>Note: You can change your login settings in your Vault account.</p>
		<p>If you are unable to log in, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</main>
	<main v-else-if="state === LoginState.Ask">
		<h1>Create a new account?</h1>
		<p>No Vault account is associated with this email address:</p>
		<pre>{{ user.email }}</pre>
		<p>Do you want to create a new Vault account?</p>

		<form class="login" @submit.prevent="state = LoginState.TOS">
			<button v-focus type="button" @click="state = LoginState.Init">I already have a Vault account</button><br><br>
			<button type="submit" ref="submit">create a new account</button>
		</form>
	</main>
	<main v-else-if="state === LoginState.TOS">
		<h1>The boring stuff</h1>
		<p>Before you continue, please make sure you understand the <a :href="links.TOS" rel="noopener" target="_blank">Terms of Service</a> and the <a :href="links.PRP" rel="noopener" target="_blank">Privacy Policy</a>.</p>

		<form class="login tos" @submit.prevent="confirmCreate">
			<input v-focus type="checkbox" required id="TOS" name="TOS"/> <label for="TOS">I have read and agree to abide by the <a :href="links.TOS" rel="noopener" target="_blank">Terms of Service</a> of The Mana World</label>
			<br><br>
			<button type="submit" ref="submit">confirm account creation</button>
		</form>
	</main>
	<main v-else>
		<div v-if="isExpired" class="expired box">
			<h1>Session expired</h1>
			<p>Your session has expired. You must log in again to continue.</p>
		</div>
		<div v-else-if="isLogout" class="expired box">
			<h1>Logged out</h1>
			<p>You have securely logged out of your Vault account.</p>
		</div>
		<div v-else class="box warning">
			<h3>Protect your account</h3>
			<p>Always make sure the address bar URL starts with <samp>https://vault.themanaworld.org/</samp></p>
		</div>
		<br>
		<h1>Email address</h1>
		<p>To proceed, you need to provide a valid email address.</p>
		<br>

		<form class="gap-no read_s login" @submit.prevent="callApi">
			<div class="form-box pa_m tinted-danger tinted-danger-bg" v-if="state === LoginState.Invalid">
				<label for="email" class="mini-label">E-mail</label>
				<input v-focus required autocorrect="off" name="email" id="email" ref="email" v-model="user.email" type="email" placeholder="your@email.com" class="input text_l pa_m">
			</div>
			<div class="form-box pa_m" v-else>
				<label for="email" class="mini-label">E-mail</label>
				<input v-focus required autocorrect="off" name="email" id="email" ref="email" v-model="user.email" type="email" placeholder="your@email.com" class="input text_l pa_m">
			</div>
			<button class="button block prime text_l pa_m bo-b_xs" type="submit" ref="submit">Verify &rarr;</button>
		</form>
	</main>
</template>

<style scoped>
form.login {
	margin-top: 1rem;
}
.expired {
	margin-bottom: 1rem;
}
button {
	cursor: pointer;
}

.warning {
	background: var(--main-2);
	padding: 1em;
	margin-bottom: 2em;

	& samp {
		font-weight: 700;
		font-family: monospace;
		background: rgba(230,230,230,50);
		border-top: solid 1px white;
		border-bottom: solid 1px white;
	}
}
</style>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator"

enum LoginState {
	Init,     // initial state
	Sent,     // magic link sent
	Ask,      // ask whether the user already has an account
	TOS,      // read TOS before account creation
	WebAuthn, // 2FA
	Error,    // misc error
	Banned,   // evil person
	Invalid,  // invalid email address
	Limit,    // hit rate limiting
	Primary,  // must use primary identity
}

@Component({
	data () {
		return { LoginState }
	},
})
export default class Login extends Vue {
	isExpired = false
	isLogout = false
	state: LoginState = LoginState.Init
	error = ""
	retry = 0
	user = {
		email: "",
		confirmed: false,
	}
	links = {
		TOS: process.env.VUE_APP_TOS,
		PRP: process.env.VUE_APP_PRP,
		support: process.env.VUE_APP_SUPPORT,
	}

	async created () {
		this.isExpired = (this.$route.params?.expired || this.$route.query?.expired) ? true : false
		this.isLogout = (this.$route.params?.logout || this.$route.query?.logout) ? true : false
	}

	async callApi () {
		const submit = this.$refs.submit as HTMLButtonElement
		submit.disabled = true

		const req = new Request(`${process.env.VUE_APP_API}/vault/session`, {
			method: "PUT",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
			},
			body: JSON.stringify({
				email: this.user.email,
				confirm: this.user.confirmed,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.state = LoginState.Error
			this.error = `Couldn't reach the API`
			console.error(err)
			return
		}

		const json = await rawResponse.json()
		submit.disabled = false

		switch (rawResponse.status) {
		case 200:
			await this.$store.commit("setLoginAttempt", this.user.email)

			if (Reflect.has(json, "key")) {
				// the API doesn't require a formal login (local testing only)
				this.$router.push({name: "authentication", params: {key: json.key}})
				return
			}

			this.state = LoginState.Sent
			return
		case 202:
			this.state = LoginState.Ask
			return
		case 400:
			this.state = LoginState.Invalid
			break
		case 401:
			// requires 2FA
			// XXX: to avoid this initial request we could cache client-side the accounts that have WebAuthn
			//      and directly show the webauthn prompt
			this.state = LoginState.WebAuthn
			return
		case 403:
			this.state = LoginState.Banned
			return
		case 404:
			this.state = LoginState.Error
			this.error = "Not yet implemented"
			return
		case 418:
			this.state = LoginState.Error
			this.error = "You Shall Not Pass!"
			return
		case 423:
			this.state = LoginState.Primary
			return
		//case 425:
		case 429:
			this.state = LoginState.Limit
			this.retry = json.retry
			return
		case 500:
			this.state = LoginState.Error
			this.error = "Internal server error"
			return
		case 502:
			this.state = LoginState.Error
			this.error = "The API is unreachable"
			return
		default:
			this.state = LoginState.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}

	async confirmCreate () {
		this.user.confirmed = true
		await this.callApi()
	}
}
</script>
